#include <stdlib.h>
#include "SDL.h"
#include "defines.h"
#include "fs.h"
#include "console.h"
#include "level.h"
#include "player.h"
#include "weapon.h"
#include "animation.h"
#include "particle.h"
#include "special.h"

/* Internally used globals */
SDL_Event anim_redraw_event;
SDL_TimerID anim_refresh_timer;
SDL_Rect anim_update_rects[2];
int anim_rects;
/*** Push a redraw event on the queue ***/
SDL_NewTimerCallback push_redraw_event(Uint32 interval,void *param) {
  SDL_PushEvent(&anim_redraw_event);
  return (SDL_NewTimerCallback)interval;
}

/*** Initialize data structures ****/
void init_animation() {
SDL_InitSubSystem(SDL_INIT_TIMER);
anim_redraw_event.user.type=SDL_USEREVENT;
anim_redraw_event.user.code=EVENT_ANIMATE_FRAME;
anim_refresh_timer=NULL;
}

void reinit_animation() {
anim_rects=1;
/* What should we update on frame redraw ? */
anim_update_rects[0].x=0;
anim_update_rects[0].y=0;
anim_update_rects[0].w=320;
anim_update_rects[0].h=240;
anim_update_rects[1].w=320;
anim_update_rects[1].h=240;

if((players_active[0]==1 && players_active[1]==1) && (players_active[2]==1 && players_active[3]==1)) {
  anim_update_rects[0].x=0;
  anim_update_rects[0].y=0;
  anim_update_rects[0].w=SCREEN_W;
  anim_update_rects[0].h=SCREEN_H;
} else {
  if((players_active[0]==0 && players_active[1]==1) && (players_active[2]==0 && players_active[3]==0)) {
    anim_update_rects[0].x=320;
  }
  if((players_active[0]==0 && players_active[1]==0) && (players_active[2]==1 && players_active[3]==0)) {
    anim_update_rects[0].y=240;
  }
  if((players_active[0]==0 && players_active[1]==0) && (players_active[2]==0 && players_active[3]==1)) {
    anim_update_rects[0].x=320;
    anim_update_rects[0].y=240;
  }
  else if((players_active[0]==1 && players_active[1]==1)) {
    anim_update_rects[0].w=640;
    if(players_active[2]) {anim_update_rects[1].x=0; anim_update_rects[1].y=240; anim_rects=2;} else if(players_active[3]) {anim_update_rects[1].x=320; anim_update_rects[1].y=240; anim_rects=2;}
  }
  else if((players_active[2]==1 && players_active[3]==1)) {
    anim_update_rects[0].y=240;
    anim_update_rects[0].w=640;
    if(players_active[0]) {anim_update_rects[1].x=0; anim_update_rects[1].y=0; anim_rects=2;} else if(players_active[1]) {anim_update_rects[1].x=320; anim_update_rects[1].y=0; anim_rects=2;}
  }
  else if((players_active[1]==1 && players_active[3]==1)) {
    anim_update_rects[0].x=320;
    anim_update_rects[0].h=480;
    if(players_active[0]) {anim_update_rects[1].x=0; anim_update_rects[1].y=0; anim_rects=2;} else if(players_active[2]) {anim_update_rects[1].x=0; anim_update_rects[1].y=240; anim_rects=2;}
  }
  else if((players_active[0]==1 && players_active[3]==1)) {
    anim_update_rects[1].x=320;
    anim_update_rects[1].y=240;
    anim_rects=2;
  }
  else if((players_active[1]==1 && players_active[2]==1)) {
    anim_update_rects[0].x=320;
    anim_update_rects[1].x=0;
    anim_update_rects[1].y=240;
    anim_rects=2;
  }
}
}

/*** Start frame counter ***/
void resume_anim() {
  if(!anim_refresh_timer)
    anim_refresh_timer=SDL_AddTimer(40,(void*)push_redraw_event,NULL);
}

/**** Stop frame counter ****/
void pause_anim() {
  if(anim_refresh_timer) {
    SDL_RemoveTimer(anim_refresh_timer);
    anim_refresh_timer=NULL;
  }
}

/**** Redraw frame ****/
void redraw_frame() {
  int r;
  if(endgame>0) endgame--;
  if(endgame==0) break_eventloop=1;
  for(r=0;r<4;r++)
    if(players_active[r]) animate_player(r);
  player_hit_specials();
  animate_level();
  animate_particles();
  animate_specials();
  animate_weapons();
  draw_level();
  draw_specials();
  draw_player();
  draw_weapons();
  draw_particles();
  draw_player_statusbars();
  SDL_UpdateRects(screen,anim_rects,anim_update_rects);
}
