#ifndef L_CONSOLE_H
#define L_CONSOLE_H

#include "SDL.h"

typedef struct {
  char fullscreen;
  char hidemouse;
} DisplayOptions;

/* The screen */
extern SDL_Surface *screen;

/* Colours */
extern Uint32 col_gray;
extern Uint32 col_snow;
extern Uint32 col_clay;

/* Set this to nonzero when you want to break out from eventloop */
extern int break_eventloop;

/* Initialize SDL library */
void init_sdl();

/* Initialize screen */
void init_video(DisplayOptions *opts);

/* Graphics */
void draw_box(int x,int y,int w,int h,char width,Uint32 color);
void putpixel(SDL_Surface *surface,int x,int y,Uint32 color);
void recolor(SDL_Surface *surface,float red,float green,float blue,float alpha);

/* Events */
void register_mousebtn(void (*callback)(SDL_MouseButtonEvent*,char down));
void register_mousemtn(void (*callback)(SDL_MouseMotionEvent*));
void register_keyboard(void (*callback)(SDL_KeyboardEvent*,Uint8));
int event_loop();

#endif
