#ifndef DEFINES_H
#define DEFINES_H

/* Misc */
#define CONF_FILE	"luola.conf"
#define HIRES_PROJ	/* Disabling this makes your projectile collisions less accurate */

/* Speeds */
#define GRAVITY	 	0.181	/* Original: 0.581 */
#define WEAP_GRAVITY 	0.1
#define THRUST	 	0.7 	/* Original: 1 */
#define MAXSPEED 	4.0	/* Original: 5 */
#define TURN_SPEED 	0.2 	/* Original: 0.1 */

#define JPLONGLIFE	400	/* How long does a jump-point last */
#define JPSHORTLIFE	25

/* Window size */
#define SCREEN_W     640
#define SCREEN_H     480
#define SCREEN_DEPTH 32

/* Graph */
#define SHIP_POSES	16
#define EXPL_FRAMES	7
#define WARP_FRAMES	21
#define WARP_LOOP	10
#define FIRE_FRAMES	26
#define FIRE_SPREAD     17
#define FIRE_RANDOM     17

/* Landscape */
#define TER_FREE	0
#define TER_GROUND	1
#define TER_UNDERWATER  2
#define TER_INDESTRUCT	3
#define TER_WATER	4
#define TER_BASE	5
#define TER_EXPLOSIVE	6
#define TER_WATERFU	7
#define TER_WATERFR	8
#define TER_WATERFD	9
#define TER_WATERFL	10
#define TER_COMBUSTABLE 11

/* Screens */
#define SCREEN_INTRO 	    0
#define SCREEN_SETTINGS	    1
#define SCREEN_KEYCONF	    2
#define SCREEN_GAMESETTINGS 3
/* Menu returns */
#define MNU_RET_SCREEN1 1
#define MNU_RET_BACK	-1

/* Menu item positions */
#define MENU_X		200
#define MENU_ITEM1	260
#define MENU_SPACING	20

/* Macros */
#ifndef min
#define min(x,y) ((x) < (y) ? (x) : (y))
#endif

#ifndef max
#define max(x,y) ((x) > (y) ? (x) : (y))
#endif

#define sqr(x) ((x)*(x))

#endif
