#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "SDL.h"
#include "SDL_image.h"

extern SDL_Surface *screen;

#include "fs.h"

/* Paths */
#define GFX_PATH "../data/gfx/"
#define DATA_PATH "../data/"
#define LEVEL_PATH "../data/levels/"
#define HOME_PATH "./"

char *getfullpath(char dir,char *filename) {
  char *fullpath=NULL;
  switch(dir) {
    case GFX_DIRECTORY:
      fullpath = (char*)malloc(sizeof(char)*(strlen(filename)+strlen(GFX_PATH)+1));
      strcpy(fullpath,GFX_PATH);
      break;
    case LEVEL_DIRECTORY:
      fullpath = (char*)malloc(sizeof(char)*(strlen(filename)+strlen(LEVEL_PATH)+1));
      strcpy(fullpath,LEVEL_PATH);
      break;
    case HOME_DIRECTORY:
      fullpath = (char*)malloc(sizeof(char)*(strlen(filename)+strlen(HOME_PATH)+1));
      strcpy(fullpath,HOME_PATH);
      break;
    }
  strcat(fullpath,filename);
  return fullpath;
}

/* Load an imagefile */
SDL_Surface *load_image(char dir,char *filename,char allownull,char enableAlpha) {
  SDL_Surface *tmp,*conv;
  char *fullpath;
  fullpath=getfullpath(dir,filename);
  tmp=IMG_Load(fullpath);
  if(tmp==NULL && allownull==0) {
    printf("Error ! Unable to load image \"%s\" %s:\n",fullpath,SDL_GetError());
    exit(1);
  }
  if(enableAlpha)
    conv = SDL_DisplayFormatAlpha(tmp);
  else
    conv = SDL_DisplayFormat(tmp);
  SDL_FreeSurface(tmp);
  if ( tmp == NULL ) {
    printf("Error ! Could not convert image \"%s\" to screen format ! %s\n",filename,SDL_GetError());
    exit(1);
  }
  free(fullpath);
  return conv;
}

void screenshot() {
  char *filename;
  filename=getfullpath(HOME_DIRECTORY,"luola_screenshot.bmp");
  if(SDL_SaveBMP(screen,filename)) {
    printf("Error saving screenshot to %s\n",filename);
  }
}
