#ifndef L_GAME_H
#define L_GAME_H

struct LevelFile {
  char *name;
  char *filename;
  char *collmap;
  struct LevelFile *next;
  struct LevelFile *prev;
};

typedef struct {
  int rounds;
  char players_in[4];
  SDLKey buttons[4][6]; /* Forward, Backward, Left,Right,Weap1,Weap2 */
  struct LevelFile *levels;
  struct LevelFile *first_level;
  struct LevelFile *last_level;
  int levelcount;
  /* Settings */
  char ship_collisions;
  char indstr_base;
  char coll_damage;
  unsigned char jumpgates;
  char jumplife;
} GameInfo;

typedef struct {
  int wins[4];
  char lastwin;
  unsigned long lifetime[4];
  int total_rounds;
} GameStatus;

void init_game();
void reinit_game();
void prematch_game();

void draw_begin_game();
void draw_weapon_selection();
void game_redraw_selection();
void fill_unused_player_screens();
int game_exec_selection();

void game_statistics();
void game_keyhandler(SDL_KeyboardEvent *event,Uint8 type);

extern GameInfo game_settings;

void save_game_config();
void load_game_config();
void scan_levels();
char *level_name(char *fname);

#endif
