#ifndef L_LEVEL_H
#define L_LEVEL_H

#include "SDL.h"

#include "game.h"
#include "vector.h"

typedef enum {Fire,Ice,Earth,Explosive} LevelFXType;

typedef struct {
  int width;		/* Width of the level in pixels */
  int height;		/* Height of the level in pixels */
  SDL_Surface *terrain;	/* Level graphics */
  char **solid;		/* Collision map */
  int player_def_x[4];  /* Beginning x coordinate for players */
  int player_def_y[4];  /* Beginning y coordinate for players */
} Level;

void init_level();
void load_level(struct LevelFile *lev);
void unload_level();
void draw_level();

inline signed char hit_solid(int x,int y);

/* Level effects */
void start_burning(int x,int y);
void alter_level(int x,int y,int recurse,LevelFXType type);
void animate_level();

/* Globals */
extern SDL_Rect cam1_rect,cam2_rect,cam3_rect,cam4_rect;
extern Level lev_level;
extern Vector gravity;
extern Uint32 lev_watercol;

#endif
