#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include "SDL_image.h"
#include "defines.h"
#include "defines.h"
#include "fs.h"
#include "console.h"
#include "intro.h"
#include "game.h"
#include "level.h"
#include "player.h"
#include "particle.h"
#include "weapon.h"
#include "animation.h"
#include "special.h"

extern GameStatus game_status;

int main(int argc,char *argv[]) {
int rval,r;
DisplayOptions opts;
/* Parse command line arguments */
opts.fullscreen=0;
opts.hidemouse=0;
if(argc>1) {
  for(r=1;r<argc;r++) {
    if(strcmp(argv[r],"--help")==0) {
      printf("Luola command line options:\n");
      printf("  --fullscreen	Full screen mode\n");
      printf("  --hidemouse	Hide the mouse when it's over the window\n");
      return 0;
    } else if(strcmp(argv[r],"--fullscreen")==0) opts.fullscreen=1;
    else if(strcmp(argv[r],"--hidemouse")==0) opts.hidemouse=1;
  }
}
/* Seed the random number generator */
srand(time(NULL));
/* Initialize */
init_sdl();
init_video(&opts);
init_level();
init_particles();
init_weapons();
init_players();
init_animation();
init_intro_screen();
init_game();
init_specials();
load_game_config();
while(1) {
  /* Intro screen */
  register_keyboard(intro_keyhandler);
  draw_intro_screen();
  rval=event_loop();
  if(rval==MNU_RET_BACK) return 0;
  /* Play ! */
  if(rval==MNU_RET_SCREEN1) {
    reinit_game();
    register_keyboard(game_keyhandler);
    draw_begin_game();
    rval=event_loop();
    if(rval==MNU_RET_SCREEN1) {
      game_status.total_rounds=0;
      while(game_settings.rounds>0) {
        register_keyboard(game_keyhandler);
        prematch_game();
        draw_weapon_selection();
        rval=event_loop()-1;
        if(rval<0) break;
        fill_unused_player_screens();
        register_keyboard(player_keyhandler);
        load_level(game_settings.levels);
	prepare_specials();
        deinit_weapons(1);
        reinit_players();
        resume_anim();
        event_loop();
        pause_anim();
	/* Check who won */
	game_status.lastwin=-1;
	for(r=0;r<4;r++) {
	  if(players[r].dead==0 && players_active[r]) {game_status.wins[r]++; game_status.lastwin=r+1; }
	}
	/* Unload level and the game goes on...*/
        unload_level();
	deinit_specials(1);
        game_settings.rounds--;
	game_status.total_rounds++;
      }
      game_statistics();
    }
  }
}
return 0;
}
