#ifndef PLAYER_H
#define PLAYER_H

#include "SDL.h"
#include "vector.h"
#include "weapon.h"

typedef struct {
  int x;
  int y;
  SDL_Surface **ship;
  SDL_Surface *shield;
  Vector vector;
  float angle;
  char thrust;
  float turn;
  double health;
  double energy;
  /* Mostly weapon related stuff */
  char dead;
  char visible;
  char shieldup;
  char ghost;
  char afterburn;
  char frozen;
  WeaponType special;
} Player;

void init_players();
void deinit_players();
void reinit_players();
void draw_player();
void draw_player_statusbars();
void animate_player(int num);
char player_damage(int plr,ProjectileType type);
inline char hit_player(int x,int y,signed char ignore,char wide);
void fire_weapon(int plr,int weapon);

void player_keyhandler(SDL_KeyboardEvent *event,Uint8 type);

extern Player players[4];
extern char players_active[4];
extern int endgame;

void ghostify(unsigned char plr,char status);

#endif
