#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <SDL_keysym.h>

#include "weapon.h"
#include "stringutil.h"

char *strip_white_space(char *str) {
  int len;
  char *newstr=NULL;
  char *s1,*s2;
  s1=str;
  s2=str+strlen(str)-1;
  while((*s1==' ' || *s1=='\n') && s1<s2) s1++;
  while((*s2==' ' || *s2=='\n') && s2>=s1) s2--;
  s2++;
  len=s2-s1;
  if(len<=0) return NULL;
  newstr=(char*)malloc(sizeof(char)*len);
  if(newstr==NULL) {
    printf("Malloc error at strip_white_space ! (attempted to allocate %d bytes\n",len);
    exit(1);
  }
  strncpy(newstr,s1,len);
  newstr[len]='\0';
  return newstr;
}

int split_string(char *str,char delim,char **left,char **right) {
  int l1;
  char *tl=NULL,*tr=NULL;
  l1=strchr(str,delim)-str;
  tl=malloc(l1);
  strncpy(tl,str,l1);
  tl[l1]=0;
  tr=malloc(strlen(str)-l1);
  tr=str+l1+1;
  
  *left=strip_white_space(tl);
  *right=tr;strip_white_space(tr);
  return 0;
}

char *key2str(int key) {
  char *str=NULL;
  int n,d;
  /* Easy picks first, ASCII ? */
  if(key>=SDLK_EXCLAIM && key<=SDLK_z) {
    str=malloc(2);
    str[0]=key;
    str[1]='\0';
    return str;
  }
  /* Maybe it's a special character ? */
  switch(key) {
    case SDLK_LSHIFT:
      return "<lshift>";
    case SDLK_RSHIFT:
      return "<rshift>";
    case SDLK_LCTRL:
      return "<lctrl>";
    case SDLK_RCTRL:
      return "<rctrl>";
    case SDLK_UP:
      return "<up>";
    case SDLK_DOWN:
      return "<down>";
    case SDLK_LEFT:
      return "<left>";
    case SDLK_RIGHT:
      return "<right>";
    case SDLK_TAB:
      return "<tab>";
    case SDLK_RETURN:
      return "<return>";
    case SDLK_SPACE:
      return "<space>";
    case SDLK_KP_PERIOD:
      return "<numpad ,>";
    case SDLK_KP_DIVIDE:
      return "<numpad />";
    case SDLK_KP_MULTIPLY:
      return "<numpad *>";
    case SDLK_KP_MINUS:
      return "<numpad ->";
    case SDLK_KP_PLUS:
      return "<numpad +>";
    case SDLK_KP_ENTER:
      return "<numpad enter>";
    case SDLK_KP_EQUALS:
      return "<numpad =>";
  }
  /* Ohkay.. How about numpad ? */
  if(key>=SDLK_KP0 && key<=SDLK_KP9) {
    str=malloc(11);
    sprintf(str,"<numpad %d>",key-SDLK_KP0);
    str[10]='\0';
    return str;
  }
  /* If all else fails, give the keysym number */
  str=malloc(6);
  str[5]='\0';
  str[0]='\'';
  str[4]='\'';
  memset(str+1,'0',3);
  n=key;
  for(d=3;d>0;d--) {
    for(;n>=pow(10,d-1);)
      if(n-pow(10,d-1)>=0) { n-=pow(10,d-1); str[4-d]++; } else break;
  }
  return str;
}

char *weap2str(int weapon) {
  switch(weapon) {
    case WCannon: return "Cannon"; /* This is the ordinary weapon, it should newer get here */
    case WGrenade: return "Grenade";
    case WMegaBomb: return "Mega bomb";
    case WMissile: return "Homing missile";
    case WCloak: return "Cloaking device";
    case WMagMine: return "Magnetic mine";
    case WMine: return "Mine";
    case WShield: return "Shield";
    case WGhostShip: return "Ghost Ship";
    case WAfterBurner: return "After Burner";
    case WWarp: return "Jump engine";
    case WClaybomb: return "Claybomb";
    case WPlastique: return "Plastic explosive";
    case WSnowball: return "Snowball";
  }
  return "BFG-9000"; /* ;-) */
}
