#ifndef L_WEAPON_H
#define L_WEAPON_H

#include "SDL.h"
#include "vector.h"
#include "weapon.h"

typedef enum {Cannon,Grenade,MegaBomb,Missile,MagMine,Mine,Claybomb,Plastique,Snowball} ProjectileType;
typedef enum {WCannon,WGrenade,WMegaBomb,WMissile,WCloak,WMagMine,WMine,WShield,WGhostShip,WAfterBurner,WWarp,WClaybomb,WPlastique,WSnowball} WeaponType;

#define WeaponCount 14

typedef struct {
  int x;
  int y;
  Vector vector;
  Vector *gravity;
  float angle; /* This is used by the homing missile */
  Uint32 color;
  ProjectileType type;
  signed char owner;
  unsigned char primed;
  int life;
} Projectile;

typedef struct {
  int x;
  int y;
  int frame;
} Explosion;

void init_weapons();
void deinit_weapons(char just_clear);
Projectile *make_projectile(int x,int y,Vector v);
void add_projectile(Projectile *proj);
void spawn_clusters(int x,int y,int count,int owner);
void add_explosion(int x,int y);
void animate_weapons();
void draw_weapons();

/* Misc weapon utility functions */
int find_nearest_player(int myX,int myY,int not_this,double *dist);

#endif
